VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CTEXT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit



'====================================================================================
'Function similair to C/C++ API functioncall 'GetPrivateProfileString' as found in
'Lib "kernel32" however completely Visual Basic!
'Parameters:
''sFileName'        Descr.: file name and path of file to be opened;
''sHeader'          Descr.: header of the item to be read;
''sKeyName'         Descr.: key of the item to be read;
''lStringWitdh'     Descr.: optional parameter indicating the length of the string
'to be returned by the function.
'Author: Eric.Groen / www.yachtgroup.com / jan 2001
'====================================================================================

Public Function GetStringOfKey(ByVal sHeader As String, _
                               ByVal sKeyName As String, _
                               ByVal sRetVal As String, _
                               ByVal sFileName As String, _
                               Optional ByVal lStringWitdh As Long) As String
Attribute GetStringOfKey.VB_Description = "Function similair to C/C++ API functioncall 'GetPrivateProfileString' as found in\r\n'Lib ""kernel32"" however completely Visual Basic! This function only accepts the default .ini settings with a header: [headername] and a key. "

    Dim sLine, sNextLine, sBuffer, sProfileString, sKeyBuffer, sLineBuffer, sHeaderBuffer As String
    Dim iCnt, iEqPos As Integer
    
    '--------------------
    'Okay, not very nice.
    '--------------------
'    On Error Resume Next
    
    '-----------------
    'Set counter to 1.
    '-----------------
    iCnt = 1
    
    '------------------------------------------
    'Open the file and read the first entry.
    '------------------------------------------
    Open sFileName For Input As #1
        Do While Not EOF(1)
            Line Input #1, sLine
            '------------------------------------------------------------------
            'If the first line (sLine) is equal to parameter sHeader then store
            'it in a buffer-property 'HeaderBuffer'; in that case the loop must
            'continue to execute.
            '------------------------------------------------------------------
            If sHeader = sLine Then sHeaderBuffer = sLine
            If sHeaderBuffer = sHeader Then
                '---------------------------------------------------------
                'Find first '=' in sLine and put it in a integer variable.
                '---------------------------------------------------------
                iEqPos = InStr(1, sLine, "=")
                '------------------------------------------------------------------
                'Increase this variable with 1 to take the next character in the
                'string and count from there.
                '------------------------------------------------------------------
                iEqPos = iEqPos + 1
                '------------------------------------------------------------
                'If sLine has a key (ending with'=') then put it in a buffer,
                'take the string until finding '=' and compare this with the
                'parameter sKey; if they match then you'll have your correct
                'GetStringOfKey. Exit the function.
                '------------------------------------------------------------
                If InStr(1, sLine, "=") Then
                    sKeyBuffer = Mid(sLine, 1, (iEqPos - 2))
                    If sKeyBuffer = sKeyName Then
                        '-------------------------------------------------------
                        'Get the string and assign it to GetStringOfKey and
                        'return the function. Do some criteria...
                        '-------------------------------------------------------
                        If IsMissing(lStringWitdh) Then
                            Exit Function
                        End If
                        If Not lStringWitdh = 0 Then
                            '-------------------------------------------------------
                            'Caution! there could be more lines under your key,
                            'so read on!
                            '-------------------------------------------------------
                            Do Until EOF(1)
                                '-------------------------------------------------------
                                'Buffer the first line..
                                '-------------------------------------------------------
                                sLine = sLine
                                '-------------------------------------------------------
                                '..and read on to the next line..
                                '-------------------------------------------------------
                                Line Input #1, sNextLine
                                '-------------------------------------------------------
                                'if this line is empty then get the string and leave
                                'else read on..
                                '-------------------------------------------------------
                                If (sNextLine = "") Then
                                    GetStringOfKey = Mid(sLine, iEqPos, _
                                                     Len(Mid(sLine, 1, lStringWitdh)))
                                    Exit Do
                                Else
                                    sNextLine = sNextLine
                                    sLine = sLine + sNextLine
                                End If
                            Loop
                        Else
                            GetStringOfKey = ""
                        End If
                        Exit Function
                    Else
                        '---------------------------------------------------------
                        'Return user defined 'return value' from parameter sRetVal.
                        '---------------------------------------------------------
                        GetStringOfKey = sRetVal
                    End If
                End If
                '---------------------------------------------------------
                'If next '[' is found then leave function, because next
                'key in file is entered.
                '---------------------------------------------------------
                If Left(sLine, 1) = Left(sLineBuffer, 1) Then Exit Function
                sLineBuffer = Left(sLine, Len(sLine))
                iCnt = iCnt + 1
            End If
         Loop
    Close #1
End Function

